;;;*************************************************************************
;; ------------------------------------------------------------
;; Functions for the complete link list
;; ------------------------------------------------------------

(define (get-oldest-link-cell)
  (let ((link (get-first-active-link all-links all-links)))
    (if link
	(extract-link-cell link)
	#f)))

(define (get-first-active-link links pred-links)
  (if (pair? links)
      (if (eq? (link-actve (car links)) 'delete)
	  (if (eq? links all-links)
	      (begin
		(set! all-links (cdr links))
		(get-first-active-link (cdr links) (cdr links)))
	      (begin
		(set-cdr! pred-links (cdr links))
		(get-first-active-link (cdr links) pred-links)))
	  (if (not (link-actve (car links)))
	      (get-first-active-link (cdr links) links)
	      (car links)))
      #f))

(define (get-oldest-eq-link-cell)
  (let ((link (get-first-active-eq-link all-eq-links all-eq-links)))
    (if link
	(extract-link-cell link)
	#f)))

(define (get-first-active-eq-link links pred-links)
  (if (pair? links)
      (if (eq? (link-actve (car links)) 'delete)
	  (if (eq? links all-eq-links)
	      (begin
		(set! all-eq-links (cdr links))
		(get-first-active-eq-link (cdr links) (cdr links)))
	      (begin
		(set-cdr! pred-links (cdr links))
		(get-first-active-eq-link (cdr links) pred-links)))
	  (if (not (link-actve (car links)))
	      (get-first-active-eq-link (cdr links) links)
	      (car links)))
      #f))

(define (extract-link-cell link)
  (let ((weight (link-weight link))
	index appropriate-link-vector-size)
    (if (eq-link? link)
	(set! appropriate-link-vector-size eq-link-vector-size)
	(set! appropriate-link-vector-size link-vector-size))
    (if (or (>= weight appropriate-link-vector-size) (< weight 0))
	(set! index (- appropriate-link-vector-size 1))
	(set! index weight))
    (if (eq-link? link)
	(extract-specified-link-from-list link (vector-ref link-vector index) (vector-ref link-vector index) index)
	(extract-specified-eq-link-from-list link (vector-ref eq-link-vector index) (vector-ref eq-link-vector index) index))))

(define (extract-specified-link-from-list link list pred-list index)
  (if (pair? list)
      (if (eq? (link-active (car list)) #t)
	  (if (eq? link (car list))
	      (if (eq? list (vector-ref link-vector index))
		  (begin
		    (vector-set! link-vector index (cdr list))
		    list)
		  (begin
		    (set-cdr! pred-list (cdr list))
		    list))
	      (begin
		(set! active-links-exist #t)
		(extract-specified-link-from-list link (cdr list) list index)))
	  (if (eq? list (vector-ref link-vector index)) ;; on the fly deletion of deletable links
	      (begin
		(vector-set! link-vector index (cdr list))
		(extract-specified-link-from-list link (vector-ref link-vector index) (vector-ref link-vector index) index))
	      (begin
		(set-cdr! pred-list (cdr list))
		(extract-specified-link-from-list link (cdr pred-list) pred-list index))))
      #f))

(define (extract-specified-eq-link-from-list link list pred-list index)
  (if (pair? list)
      (if (eq? (link-active (car list)) #t)
	  (if (eq? link (car list))
	      (if (eq? list (vector-ref eq-link-vector index))
		  (begin
		    (vector-set! eq-link-vector index (cdr list))
		    list)
		  (begin
		    (set-cdr! pred-list (cdr list))
		    list))
	      (begin
		(set! active-eq-links-exist #t)
		(extract-specified-eq-link-from-list link (cdr list) list index)))
	  (if (eq? list (vector-ref eq-link-vector index)) ;; on the fly deletion of deletable links
	      (begin
		(vector-set! eq-link-vector index (cdr list))
		(extract-specified-eq-link-from-list link (vector-ref eq-link-vector index) 
						     (vector-ref eq-link-vector index) index))
	      (begin
		(set-cdr! pred-list (cdr list))
		(extract-specified-eq-link-from-list link (cdr pred-list) pred-list index))))
      #f))
