(define (insert-clause-and-factors-in-clauselist clause clauses)
  (if (or tautologies (non-tautological clause))
      (if (unit-clause clause)
	  (begin
	    (if (and preprocess  (not (eq? falsum (car (clause-subgoals clause)))))
		(begin
		  (if gr-lemmas (insert-subgoal-in-gr-index (car (clause-subgoals clause))))
		  (insert-subgoal-in-index (car (clause-subgoals clause)) 'unit)))
	    (insert-new-clause-in-clauselist clause clauselist))
	  (insert-subgoals-factors-in-clauselist (clause-subgoals clause)
						 (insert-new-clause-in-clauselist clause clauses)))
      (begin
	(if (not silent) 
	    (begin 
	      (display "deleted tautological input ")
	      (display-clause clause)
	      (newline)))
	clauses))))

(define (insert-subgoals-factors-in-clauselist subgoals clauses)
  (if (and (pair? subgoals) (not (null? (cdr subgoals))))
      (insert-subgoals-factors-in-clauselist (cdr subgoals) 
					     (insert-subgoal-factors-in-clauselist (car subgoals) (cdr subgoals) clauses))
      clauses))

(define (insert-subgoal-factors-in-clauselist subgoal rest-subgoals clauses)
  (if (and (pair? rest-subgoals) (sign-predsym= subgoal (car rest-subgoals)))
      (begin
	(if (eq-subgoal? subgoal)
	    (let ((left (ref (car (subgoal-terms subgoal))))
		  (right (ref (cadr (subgoal-terms subgoal)))))
	      (set-subgoal-terms subgoal (list right left))
	      (if (unify-lists-stop (subgoal-terms subgoal) (subgoal-terms (car rest-subgoals)))
		  (let ((new-factor (renamed-factor (subgoal-clause subgoal))))
		    (unbind-vars)
		    (set! clauses (insert-clause-and-factors-in-clauselist new-factor clauses))))
	      (set-subgoal-terms subgoal (list left right))))
	(if (unify-lists-stop (subgoal-terms subgoal) (subgoal-terms (car rest-subgoals)))
	    (let ((new-factor (renamed-factor (subgoal-clause subgoal))))
	      (unbind-vars)
	      (set! clauses (insert-clause-and-factors-in-clauselist new-factor clauses))))
	(insert-subgoal-factors-in-clauselist subgoal (cdr rest-subgoals) clauses))
      clauses))

(define (renamed-factor clause)
  (let ((factor (new-clause)) (factor-input (new-input)))
    (set-clause-foldup-lits factor '())
    (trail-stop)
    (set! unsimplifieds (unsimplifiable-subgoals (clause-subgoals clause)))
    (compute-current-weights unsimplifieds)
    (set-clause-subgoals factor (renamed-subgoals unsimplifieds))
    (unrename-vars)
    (if equality (set-clause-subgoals factor (eliminate-var-disequations (clause-subgoals factor))))
    (if (and equality (not ordered-eq))
	(subgoals-orientate-disequations (clause-subgoals factor)))
    (set-clause-unsimplified factor (length (clause-subgoals factor)))
    (set! factor-nr (+ factor-nr 1))
    (if (null? (clause-subgoals factor))
	(set-clause-subgoals factor (list falsum)))
    (set-clause-variables factor (variables-in-subgoals (clause-subgoals factor) '()))
    (set-clause-nr-variables factor (length (clause-variables factor)))
    (set-subgoals-pointers (clause-subgoals factor) factor)
    (set-clause-input factor factor-input) 
    (set! current-clause-nr (+ current-clause-nr 1))
    (set-input-length factor-input (length (clause-subgoals factor)))
    (set-input-number factor-input current-clause-nr)
    (set-input-name factor-input (input-name (clause-input clause)))
    (set-input-type factor-input (input-type (clause-input clause)))
    (set-input-copies factor-input (list factor))
    (set-input-all-copies factor-input (input-copies factor-input))
    (set-input-variant-index factor-input (cons 0 '()))
    (set-clause-initial factor #t)
    (set-input-complexity factor-input (compute-clause-complexity factor))
    (if (not norel) (set-clause-relevant factor (clause-relevant clause)))
    factor))

(define (set-subgoals-pointers subgoals clause)
  (if (pair? subgoals)
      (begin
	(set-subgoal-clause (car subgoals) clause)
	(set-subgoal-misc (car subgoals) #f)
	(set-subgoals-pointers (cdr subgoals) clause))))
